/**********************************************************************

  evthandler.h -

  $Author: phasis68 $
  $Date: 2003/05/12 05:47:58 $
  created at: 2003-04-14 11:02

  Copyright (C) 2003  Park Heesob

**********************************************************************/


#ifndef WXRUBY_EVTHANDLER_H
#define WXRUBY_EVTHANDLER_H

class wxRbCallback : public wxObject {
    DECLARE_ABSTRACT_CLASS(wxRbCallback);
public:
    wxRbCallback(char *func,VALUE klass);
    wxRbCallback(const wxRbCallback &other);

    void EventThunker(wxEvent &event);

    char   *m_func;
    VALUE   m_self;
};


class WxEvtHandler {
public:
    static VALUE alloc(VALUE self);
    static VALUE init0(wxEvtHandler *handler);
    static void Connect(VALUE argv0,VALUE argv1,VALUE argv2,VALUE argv3,VALUE argv4);
    static void AddPendingEvent(VALUE self,VALUE vevent);
    static VALUE GetClientData(VALUE self);
    static VALUE GetEvtHandlerEnabled(VALUE self);
    static VALUE GetNextHandler(VALUE self);
    static VALUE GetPreviousHandler(VALUE self);
    static VALUE ProcessEvent(VALUE self,VALUE vevent);
    static void SetClientData(VALUE self,VALUE vdata);
    static void SetEvtHandlerEnabled(VALUE self,VALUE venabled);
    static void SetNextHandler(VALUE self,VALUE vhandler);
    static void SetPreviousHandler(VALUE self,VALUE vhandler);

    static void WxRbEVT_ACTIVATE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_ACTIVATE_APP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_BUTTON(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR_DAY(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR_MONTH(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR_SEL_CHANGED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR_WEEKDAY_CLICKED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CALENDAR_YEAR(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CHAR(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_CHAR_HOOK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_CHECKBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CHECKLISTBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CHILD_FOCUS(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_CHOICE(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CLOSE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_COMBOBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND(VALUE self,VALUE win,VALUE id,VALUE cmd,VALUE func);
    static void WxRbEVT_COMMAND_ENTER(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_KILL_FOCUS(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_LEFT_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_LEFT_DCLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_RANGE(VALUE self,VALUE win,VALUE id1,VALUE id2,VALUE cmd,VALUE func);
    static void WxRbEVT_COMMAND_RIGHT_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_RIGHT_DCLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_BOTTOM(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_LINEDOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_LINEUP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_PAGEDOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_PAGEUP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_THUMBRELEASE(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_THUMBTRACK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLLWIN_TOP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_BOTTOM(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_LINEDOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_LINEUP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_PAGEDOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_PAGEUP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_THUMBRELEASE(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_THUMBTRACK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SCROLL_TOP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_COMMAND_SET_FOCUS(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_CONTEXT_MENU(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_DETAILED_HELP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_DETAILED_HELP_RANGE(VALUE self,VALUE win,VALUE id,VALUE id2,VALUE func);
    static void WxRbEVT_DROP_FILES(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_END_PROCESS(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_END_SESSION(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_ENTER_WINDOW(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_ERASE_BACKGROUND(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_HELP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_HELP_RANGE(VALUE self,VALUE win,VALUE id,VALUE id2,VALUE func);
    static void WxRbEVT_ICONIZE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_IDLE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_INIT_DIALOG(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_JOYSTICK_EVENTS(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_JOY_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_JOY_MOVE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_JOY_UP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_JOY_ZMOVE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_KEY_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_KEY_UP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_KILL_FOCUS(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_LEAVE_WINDOW(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_LEFT_DCLICK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_LEFT_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_LEFT_UP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_LISTBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LISTBOX_DCLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_MAXIMIZE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MENU(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_MENU_HIGHLIGHT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_MENU_HIGHLIGHT_ALL(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MENU_RANGE(VALUE self,VALUE win,VALUE id1,VALUE id2,VALUE func);
    static void WxRbEVT_MIDDLE_DCLICK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MIDDLE_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MIDDLE_UP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MOTION(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MOUSEWHEEL(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MOUSE_EVENTS(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_MOVE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_NAVIGATION_KEY(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_NOTEBOOK_PAGE_CHANGED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_NOTEBOOK_PAGE_CHANGING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_PAINT(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_PALETTE_CHANGED(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_QUERY_END_SESSION(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_QUERY_NEW_PALETTE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_RADIOBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_RADIOBUTTON(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_RIGHT_DCLICK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_RIGHT_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_RIGHT_UP(VALUE self,VALUE win,VALUE func);
#if wxUSE_SASH
    static void WxRbEVT_SASH_DRAGGED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SASH_DRAGGED_RANGE(VALUE self,VALUE win,VALUE id1,VALUE id2,VALUE func);
    static void WxRbEVT_QUERY_LAYOUT_INFO(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_CALCULATE_LAYOUT(VALUE self,VALUE win,VALUE func);
#endif
    static void WxRbEVT_SCROLL(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_BOTTOM(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_LINEDOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_LINEUP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_PAGEDOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_PAGEUP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_THUMBRELEASE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_THUMBTRACK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLLWIN_TOP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_BOTTOM(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_LINEDOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_LINEUP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_PAGEDOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_PAGEUP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_THUMBRELEASE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_THUMBTRACK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SCROLL_TOP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SET_FOCUS(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SHOW(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SIZE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_SLIDER(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPIN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPINCTRL(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPIN_DOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPIN_UP(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPLITTER_DOUBLECLICKED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPLITTER_SASH_POS_CHANGED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPLITTER_SASH_POS_CHANGING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SPLITTER_UNSPLIT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SYS_COLOUR_CHANGED(VALUE self,VALUE win,VALUE func);
#ifdef __WXMSW__
    static void WxRbEVT_TASKBAR_LEFT_DCLICK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_LEFT_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_LEFT_UP(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_MOVE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_RIGHT_DCLICK(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_RIGHT_DOWN(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_TASKBAR_RIGHT_UP(VALUE self,VALUE win,VALUE func);
#endif
    static void WxRbEVT_TEXT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TEXT_ENTER(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TEXT_MAXLEN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TEXT_URL(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TIMER(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TOGGLEBUTTON(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TOOL(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TOOL_ENTER(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TOOL_RANGE(VALUE self,VALUE win,VALUE id,VALUE id2,VALUE func);
    static void WxRbEVT_TOOL_RCLICKED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TOOL_RCLICKED_RANGE(VALUE self,VALUE win,VALUE id,VALUE id2,VALUE func);
    static void WxRbEVT_UPDATE_UI(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_UPDATE_UI_RANGE(VALUE self,VALUE win,VALUE id,VALUE id2,VALUE func);
    static void WxRbEVT_VLBOX(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_WINDOW_CREATE(VALUE self,VALUE win,VALUE func);
    static void WxRbEVT_WINDOW_DESTROY(VALUE self,VALUE win,VALUE func);

    static void WxRbEVT_LIST_BEGIN_DRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_BEGIN_LABEL_EDIT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_BEGIN_RDRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_CACHE_HINT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_COL_BEGIN_DRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_COL_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_COL_DRAGGING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_COL_END_DRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_COL_RIGHT_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_DELETE_ALL_ITEMS(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_DELETE_ITEM(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_END_LABEL_EDIT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_GET_INFO(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_INSERT_ITEM(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_ACTIVATED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_DESELECTED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_FOCUSED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_MIDDLE_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_RIGHT_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_ITEM_SELECTED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_KEY_DOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_LIST_SET_INFO(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_FIND(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_FIND_NEXT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_FIND_REPLACE(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_FIND_REPLACE_ALL(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_FIND_CLOSE(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_SOCKET(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_BEGIN_DRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_BEGIN_LABEL_EDIT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_BEGIN_RDRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_DELETE_ITEM(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_END_DRAG(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_END_LABEL_EDIT(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_GET_INFO(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_ACTIVATED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_COLLAPSED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_COLLAPSING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_EXPANDED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_EXPANDING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_MIDDLE_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_ITEM_RIGHT_CLICK(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_KEY_DOWN(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_SEL_CHANGED(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_SEL_CHANGING(VALUE self,VALUE win,VALUE id,VALUE func);
    static void WxRbEVT_TREE_SET_INFO(VALUE self,VALUE win,VALUE id,VALUE func);
};

#endif

