/**********************************************************************

  window.h -

  $Author: phasis68 $
  $Date: 2003/05/07 07:36:32 $
  created at: 2003-04-14 11:02

  Copyright (C) 2003  Park Heesob

**********************************************************************/


#ifndef WXRUBY_WINDOW_H
#define WXRUBY_WINDOW_H

#include "wx/splitter.h"

class WxClassInfo {
public:
    static VALUE alloc(VALUE self);
    static VALUE init0(wxClassInfo *classinfo);
    static VALUE GetClassName(VALUE self);
};

class WxWindow {
public:
    static VALUE alloc(VALUE self);
    static VALUE init(int argc, VALUE *argv, VALUE self);
    static VALUE init0(wxWindow *window);
    static void AddChild(VALUE self,VALUE vchild);
    static void CaptureMouse(VALUE self);
    static void Centre(int argc, VALUE *argv, VALUE self);
    static void CentreOnParent(int argc, VALUE *argv, VALUE self);
    static void CentreOnScreen(int argc, VALUE *argv, VALUE self);
    static void Clear(VALUE self);
    static VALUE ClientToScreen(int argc, VALUE *argv, VALUE self);
    static void Close(VALUE self, VALUE vforce);
    static VALUE ConvertDialogToPixels(VALUE self,VALUE argv);
    static VALUE ConvertPixelsToDialog(VALUE self,VALUE argv);
    static VALUE Destroy(VALUE self);
    static void DestroyChildren(VALUE self);
    static void Disable(VALUE self);
#ifdef __WXMSW__
    static void DragAcceptFiles(VALUE self,VALUE vaccept);
#endif
    static VALUE Enable(int argc, VALUE *argv, VALUE self);
    static VALUE FindFocus(VALUE self);
    static VALUE FindWindow(VALUE self,VALUE argv);
    static VALUE FindWindowById(int argc, VALUE *argv, VALUE self);
    static VALUE FindWindowByLabel(int argc, VALUE *argv, VALUE self);
    static VALUE FindWindowByName(int argc, VALUE *argv, VALUE self);
    static void Fit(VALUE self);
    static void FitInside(VALUE self);
    static void Freeze(VALUE self);
    static VALUE GetAdjustedBestSize(VALUE self);
    static VALUE GetBackgroundColour(VALUE self);
    static VALUE GetBestSize(VALUE self);
    static VALUE GetCapture(VALUE self);
    static VALUE GetCaret(VALUE self);
    static VALUE GetCharHeight(VALUE self);
    static VALUE GetCharWidth(VALUE self);
    static VALUE GetClientSizeWH(VALUE self);
    static VALUE GetClientSize(VALUE self);
    static VALUE GetConstraints(VALUE self);
    static VALUE GetContainingSizer(VALUE self);
    static VALUE GetExtraStyle(VALUE self);
    static VALUE GetFont(VALUE self);
    static VALUE GetForegroundColour(VALUE self);
    static VALUE GetGrandParent(VALUE self);
    static VALUE GetHandle(VALUE self);
    static VALUE GetHelpText(VALUE self);
    static VALUE GetId(VALUE self);
    static VALUE GetLabel(VALUE self);
    static VALUE GetName(VALUE self);
    static VALUE GetParent(VALUE self);
    static VALUE GetPosition(VALUE self);
    static VALUE GetPositionXY(VALUE self);
    static VALUE GetRect(VALUE self);
    static VALUE GetScrollPos(VALUE self,VALUE vorientation);
    static VALUE GetScrollRange(VALUE self,VALUE vorientation);
    static VALUE GetScrollThumb(VALUE self,VALUE vorientation);
    static VALUE GetSize(VALUE self);
    static VALUE GetSizeWH(VALUE self);
    static VALUE GetSizer(VALUE self);
    static VALUE GetTextExtent(int argc, VALUE *argv, VALUE self);
    static VALUE GetTitle(VALUE self);
    static VALUE GetUpdateRegion(VALUE self);
    static VALUE GetValidator(VALUE self);
    static VALUE GetVirtualSize(VALUE self);
    static VALUE GetWindowStyle(VALUE self);
    static VALUE GetWindowStyleFlag(VALUE self);
    static VALUE HasCapture(VALUE self);
    static VALUE Hide(VALUE self);
    static void InitDialog(VALUE self);
    static VALUE IsEnabled(VALUE self);
    static VALUE IsExposed(int argc, VALUE *argv, VALUE self);
    static VALUE IsRetained(VALUE self);
    static VALUE IsShown(VALUE self);
    static VALUE IsTopLevel(VALUE self);
    static VALUE Layout(VALUE self);
    static void Lower(VALUE self);
    static void MakeModal(VALUE self,VALUE vflag);
    static void Move(int argc, VALUE *argv, VALUE self);
    static VALUE PopupMenu(int argc, VALUE *argv, VALUE self);
    static void Raise(VALUE self);
    static void Refresh(int argc, VALUE *argv, VALUE self);
    static void RefreshRect(VALUE self,VALUE vrect);
    static void ReleaseMouse(VALUE self);
    static void RemoveChild(VALUE self,VALUE vchild);
    static VALUE Reparent(VALUE self,VALUE vnewParent);
    static VALUE ScreenToClient(int argc, VALUE *argv, VALUE self);
    static VALUE ScrollLines(VALUE self,VALUE vlines);
    static VALUE ScrollPages(VALUE self,VALUE vpages);
    static void ScrollWindow(int argc, VALUE *argv, VALUE self);
    static void SetAutoLayout(VALUE self,VALUE vautoLayout);
    static void SetBackgroundColour(VALUE self,VALUE vcolour);
    static void SetCaret(VALUE self,VALUE vcaret);
    static void SetClientSize(int argc, VALUE *argv, VALUE self);
    static void SetConstraints(VALUE self,VALUE vconstraints);
    static void SetContainingSizer(VALUE self,VALUE vsizer);
    static void SetCursor(VALUE self,VALUE vcursor);
    static void SetExtraStyle(VALUE self,VALUE vexStyle);
    static void SetFocus(VALUE self);
    static void SetFocusFromKbd(VALUE self);
    static void SetFont(VALUE self,VALUE vfont);
    static void SetForegroundColour(VALUE self,VALUE vcolour);
    static void SetHelpText(VALUE self,VALUE vhelpText);
    static void SetId(VALUE self,VALUE vid);
    static void SetName(VALUE self,VALUE vname);
    static void SetPalette(VALUE self,VALUE vpalette);
    static void SetScrollPos(int argc, VALUE *argv, VALUE self);
    static void SetScrollbar(int argc, VALUE *argv, VALUE self);
    static void SetSize(int argc, VALUE *argv, VALUE self);
    static void SetSizeHints(int argc, VALUE *argv, VALUE self);
    static void SetSizer(int argc, VALUE *argv, VALUE self);
    static void SetSizerAndFit(int argc, VALUE *argv, VALUE self);
    static void SetThemeEnabled(VALUE self,VALUE venable);
    static void SetTitle(VALUE self,VALUE vtitle);
    static void SetValidator(VALUE self,VALUE vvalidator);
    static void SetVirtualSize(int argc, VALUE *argv, VALUE self);
    static void SetVirtualSizeHints(int argc, VALUE *argv, VALUE self);
    static void SetWindowStyle(VALUE self,VALUE vstyle);
    static void SetWindowStyleFlag(VALUE self,VALUE vstyle);
    static void Show(int argc, VALUE *argv, VALUE self);
    static void Thaw(VALUE self);
    static VALUE TransferDataFromWindow(VALUE self);
    static VALUE TransferDataToWindow(VALUE self);
    static void Update(VALUE self);
    static void WarpPointer(VALUE self,VALUE vx,VALUE vy);
    static void SetToolTip(VALUE self,VALUE vtip);
    static VALUE GetToolTip(VALUE self);
    static VALUE GetClassInfo(VALUE self);
#ifdef __WXMSW__
    static VALUE GetHWND(VALUE self);
#endif
    static void free(VALUE self);
};

class WxSplitterWindow {
public:
    static VALUE alloc(VALUE self);
    static VALUE init(int argc, VALUE *argv, VALUE self);
    static VALUE GetMinimumPaneSize(VALUE self);
    static VALUE GetSashPosition(VALUE self);
    static VALUE GetSplitMode(VALUE self);
    static VALUE GetWindow1(VALUE self);
    static VALUE GetWindow2(VALUE self);
    static void Initialize(VALUE self,VALUE vwindow);
    static VALUE IsSplit(VALUE self);
    static VALUE ReplaceWindow(VALUE self,VALUE vwinOld,VALUE vwinNew);
    static void SetMinimumPaneSize(VALUE self,VALUE vpaneSize);
    static void SetSashPosition(int argc, VALUE *argv, VALUE self);
    static void SetSplitMode(VALUE self,VALUE vmode);
    static VALUE SplitHorizontally(int argc, VALUE *argv, VALUE self);
    static VALUE SplitVertically(int argc, VALUE *argv, VALUE self);
    static VALUE Unsplit(int argc, VALUE *argv, VALUE self);
};

#endif

